Unit MizMode;
{$G+}
INTERFACE
 Type
   PalRec = record
       R   : array[0..255] of byte;
       G   : array[0..255] of byte;
       B   : array[0..255] of byte;
     end;
   AniInfo = record
         x1  : integer;
         y1  : integer;
         x2  : integer;
         y2  : integer;
     frames  : word;
    end;
	Font = Record
               	   Info        : Array[0..4095] Of Byte;
		   Color       : Byte;
		   Spacing     : Byte;
		   BackGround  : Byte;
		   EraseBackGround : Boolean;
      End;

   PointerArray = Array[1..30] Of Pointer;
   CompressArray = Array[1..400] Of Byte;
 Var screen   : pointer;
     yOffsets : array[0..199] of word;
     scrn     : byte absolute $a000:000;
     segment  : word;
     OfSet    : word;
     FadePal  : PalRec;

{}

  Function   Valid(s:string):boolean;
  Procedure  SetMode(mode : word);
  Procedure  CLS(color : byte);
  Procedure  VRT;
  Procedure  SetFader;
  Procedure  FadeOut(rate : integer);
  Procedure  FadeIn(rate : integer);
  Procedure  RotatePal(initial,final : byte;Forward:boolean);
  Procedure  Blur(intensity : integer);
  Procedure  PutPixel(x,y : integer;col : byte);
  Function   GetPixel(x,y : integer) : byte;
  Procedure  Line(x1,y1,x2,y2 : integer;color : word);
  Procedure  Circle(Control, X, Y, Radius, Color : Word);
  Procedure  SetRadPal;
  Procedure  SetPal(col,r,g,b:byte);
  Procedure  GetPal(Col : Byte; Var R,G,B : Byte);
  Procedure  PutImage(x,y: Integer; var BitMap);
  Procedure  PutSp(x,y: Integer; var BitMap);
  Procedure  PutSpr(x1,y1,x2,y2 : Integer;var BitMap; var Mask : pointer);
  Procedure  DelSpr(x1,y1 : Integer;var BitMap);
  Procedure  GetImage(x1,y1,x2,y2: Integer; var BitMap);
  Function   ImageSize(x1,y1,x2,y2:integer):word;
  Procedure  ShowPCX(filename : string);
  Procedure  ShowMIZ(xres,yres : integer;filename : string);
  Procedure  ShowMIZf(xres,yres : integer;filename : string);
  Procedure  SaveMiz(xres,yres,xres2,yres2 : integer;filename:string);
  Procedure  LoadAni(filename:string; var P : PointerArray);
  Procedure  FreeAni(filename:string; var P : PointerArray);

  Procedure  LoadAnim(St : String; Var P  : Pointer);
  Procedure  LoadAnims(St : String; Var P  : PointerArray);
  Procedure  FreeAnim(Var P  : Pointer);
  Procedure  FreeAnims(Var P  : PointerArray);
  Procedure  PutAnim(x1,y1 : integer;var p);

  Procedure  LoadFont(St : String; Var MyFont : Font);
  Procedure  WriteCh13(X, Y : Integer; Ch : Char; Var MyFont : Font;color:byte);
  Procedure  WriteLn13(X, Y : Integer; St : String; Var MyFont : Font;color:byte);
  Function   Int2Str(L : LongInt) : string;

  Procedure  Pauze(ms : Word);
  Procedure  ClearKeys;
  Procedure  FastKeys;

{}

IMPLEMENTATION

{}
Function Valid(s:string):boolean;
 var f:file;
  begin
   assign(f,s);
    {$i-}
   reset(f);
   close(f);
    {$i+}
     if ioresult <> 0 then valid := false
      else valid := true;
end;
{}
  Procedure SetMode(mode : word); assembler;
   asm;
    mov ax,mode;
    int 10h;
   end;
{}
  Procedure Cls(color : byte);
    begin
      fillchar(scrn,64000,color);
    end;
{}
procedure VRT; assembler;
asm
                mov     dx,3DAh
@WaitVR1:        in      al,dx
                test    al,8
                jne     @WaitVR1
@WaitVR2:        in      al,dx
                test    al,8
                je      @WaitVR2
end;
{}
  Procedure SetFader;
   var col,r,g,b : byte;
    begin
     for col := 0 to 255 do
      begin
        GetPal(Col,r,g,b);
        FadePal.r[col] := r;
        FadePal.g[col] := g;
        FadePal.b[col] := b;
      end;
    end;
{}
 Procedure FadeOut(rate : integer);
   var j,col,r,g,b : byte;
    begin
   For J := 0 to 63 do
       begin
     For Col := 0 to 255 do
       begin
        GetPal(Col,r,g,b);
         If R>0 then Dec(R,1);
         If G>0 then Dec(G,1);
         If B>0 then Dec(B,1);
        SetPal(Col,r,g,b);
       end;
         Pauze(rate);
      end;
    end;
{}
  Procedure FadeIn(rate : integer);
   var j,col,r,g,b : byte;
    begin
     For J := 0 to 63 do
     begin
      For Col := 0 to 255 do
       begin
        GetPal(col,r,g,b);
         If R < FadePal.R[col] then Inc(R,1);
         If G < FadePal.G[col] then Inc(G,1);
         If B < FadePal.B[col] then Inc(B,1);
        SetPal(col,r,g,b);
       end;
      Pauze(rate);
     end;
    end;
{}
       Procedure RotatePal(initial,final : byte;Forward:boolean);
        var j,r,g,b : byte;
         begin
           If Forward then begin
             GetPal(initial,r,g,b);
             SetPal(final,r,g,b);
              For J := initial to (final-1) do
               begin
                Getpal(J+1,r,g,b);
                SetPal(J,r,g,b);
               end; end
           Else begin
             GetPal(final,r,g,b);
             SetPal(initial,r,g,b);
              For J := final downto (initial+1) do
               begin
                Getpal(J-1,r,g,b);
                SetPal(J,r,g,b);
               end; end
         end;
{}
  Procedure Blur(Intensity : integer);
        var X,Y : integer;Col : byte;Right,Down : integer;

                   Procedure Bar(x1,y1,x2,y2:integer;col : byte);
                    var Y : integer;
                     begin
                      If x1 < 0 then x1 := 0;
                      If y1 < 0 then y1 := 0;
                      If x2 > 319 then x2:=319;
                      If y2 > 199 then y2:=199;
                       For Y := y1 to y2 do
                         Line(x1,Y,x2,Y,Col);
                     end;

         begin
          Inc(Intensity);
          Down  := 199 div Intensity;
          Right := 319 div Intensity;
           For Y := 0 to Down do
             For X := 0 to Right do
              begin
                Col := GetPixel(X*Intensity,Y*Intensity);
                  Bar((X*Intensity)-(Intensity div 2),(Y*Intensity)-(Intensity div 2),
                      (X*Intensity)+(Intensity div 2),(Y*Intensity)+(Intensity div 2),Col);
              end;
         end;
{}
  Procedure PutPixel(x,y : integer; col : byte);
    begin
     Mem[$a000:(Y*320)+X] := col;
    end;
{}
  Function GetPixel(x,y : integer) : byte;
    begin
     GetPixel := Mem[$a000:(Y*320)+X];
    end;
{}
procedure Line(X1, Y1, X2, Y2: integer; Color:word);
var
   i, s,
   d1x, d1y, d1t,
   d2x, d2y, d2t,
   u, v, m, n:integer;
   adr:word;
begin
     u:= X2 - X1;
     v:= Y2 - Y1;
     d1x:= 0;
     d1y:= 0;
     if u > 0 then d1x:= 1;
     if u < 0 then d1x:= -1;
     if v > 0 then d1y:= 320;
     if v < 0 then d1y:= -320;
     d2x:= d1x;
     d2y:= 0;
     m:= ABS(u);
     n:= ABS(v);
     if not (M > N) then
     begin
          d2x:=0;
          d2y:=d1y;
          i:= m;
          m:= n;
          n:= i;
     end;
     s:= m shr 1;
     adr:= yoffsets[y1] + X1;
     d1t:= d1x + d1y;
     d2t:= d2x + d2y;
     asm
        les di,screen
        add di,adr
        mov ax, [color]
        mov bx, [s]
        mov dx, [n]
        mov si, [m]
        mov cx, [m]
        inc cx
     @@top:
        add bx, dx { s:=3D s + n }
        mov es:[di],al
        cmp bx,si
        jl  @@2
        sub bx, si
        add di, [d1t]
        dec cx
        jnz @@top
        jmp @@exit
     @@2:
        add di, [d2t]
        dec cx
        jnz @@top
     @@exit:
     end;
end;
{}
Procedure Circle(Control, X, Y, Radius, Color : Word); Assembler;
	Asm
   	MOV AX, Segment
      MOV ES, AX
      MOV SI, Radius     	{ XI := R }
      MOV DI, 0      { YI := 0 }
      MOV CX, Radius
      SHR CX, 1      { N := XI Div 2 }
      MOV AX, Control
      CMP AX, 1
      JE @Filled

@Hollow:

      @Loope:
			{putpix}
		   MOV BX, 320
		   MOV AX, Y
         SUB AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, SI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         SUB AX, SI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, DI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         SUB AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         ADD BX, SI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         SUB AX, SI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         ADD BX, DI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         ADD AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, SI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         ADD AX, SI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, DI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         ADD AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         ADD BX, SI
         MOV DX, Color
         MOV ES:[BX], DL
		   MOV BX, 320
		   MOV AX, Y
         ADD AX, SI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         ADD BX, DI
         MOV DX, Color
         MOV ES:[BX], DL
			{putpix}
         ADD CX, DI  { N := N + YI }
         CMP CX, SI  { If N > XI Then }
         JNG @Skip   { Do This }
           DEC SI    	{ XI := XI - 1 }
           SUB CX, SI	{ N := N - XI }
         @Skip:
         INC DI      { YI := YI + 1 }
      CMP DI, SI
      JNG @Loope
      JMP @End

@Filled:

      @Loopeb:
			{putpix}
		   MOV BX, 320
		   MOV AX, Y
         SUB AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, SI
         MOV DX, CX           { Part 2 }
         XCHG BX, DI
         MOV AX, Color
         MOV CX, SI
			SHL CX, 1
         inc cx
			REP STOSB
         MOV DI, BX
         MOV CX, DX

		   MOV BX, 320
		   MOV AX, Y
         ADD AX, DI
		   MUL BX
		   MOV BX, AX
		   ADD BX, X
         SUB BX, SI
         MOV DX, CX           { Part 3 }
         XCHG BX, DI
         MOV AX, Color
         MOV CX, SI
			SHL CX, 1
         inc cx
			REP STOSB
         MOV DI, BX
         MOV CX, DX
			{putpix}
         ADD CX, DI  { N := N + YI }
         CMP CX, SI  { If N > XI Then }
         JNG @Skipb   { Do This }
           DEC SI    	{ XI := XI - 1 }
           SUB CX, SI	{ N := N - XI }
				{putpix}
			   MOV BX, 320
			   MOV AX, Y
	         SUB AX, SI
            dec ax
			   MUL BX
			   MOV BX, AX
			   ADD BX, X
   	      SUB BX, DI
	         MOV DX, CX        { Part 1 }
	         MOV AX, Color
	         MOV CX, DI
				SHL CX, 1
            inc cx
	         XCHG BX, DI
				REP STOSB
	         MOV DI, BX
	         MOV CX, DX

			   MOV BX, 320
			   MOV AX, Y
	         ADD AX, SI
            inc ax
			   MUL BX
			   MOV BX, AX
			   ADD BX, X
   	      SUB BX, DI
	         MOV DX, CX
	         MOV AX, Color         { Part 4 }
	         MOV CX, DI
				SHL CX, 1
            inc cx
	         XCHG BX, DI
				REP STOSB
	         MOV DI, BX
	         MOV CX, DX
				{putpix}
         @Skipb:
         INC DI      { YI := YI + 1 }
      CMP DI, SI
      JNG @Loopeb

      @End:
   End;
{}
  Procedure SetRadPal;
   const RadPal : array[0..255,1..3] of byte =
  ((0,0,0),(0,0,42),(0,42,0),(0,42,42),(42,0,0),(42,0,42),(42,21,0),(42,42,42),
   (21,21,21),(21,21,63),(21,63,21),(21,63,63),(63,21,21),(63,21,63),(63,63,21),(63,63,63),
   (28,23,6),(63,0,0),(63,1,0),(63,2,0),(63,3,0),(63,4,0),(63,5,0),(63,6,0),
   (63,7,0),(63,8,0),(63,9,0),(63,10,0),(63,11,0),(63,12,0),(63,13,0),(63,14,0),
   (63,15,0),(63,16,0),(63,17,0),(63,18,0),(63,19,0),(63,20,0),(63,21,0),(63,22,0),
   (63,23,0),(63,24,0),(63,25,0),(63,26,0),(63,27,0),(63,28,0),(63,29,0),(63,30,0),
   (63,31,0),(63,32,0),(63,33,0),(63,34,0),(63,35,0),(63,36,0),(63,37,0),(63,38,0),
   (63,39,0),(63,40,0),(63,41,0),(63,42,0),(63,43,0),(63,44,0),(63,45,0),(63,46,0),
   (63,47,0),(63,48,0),(63,49,0),(63,50,0),(63,51,0),(63,52,0),(63,53,0),(63,54,0),
   (63,55,0),(63,56,0),(63,57,0),(63,58,0),(63,59,0),(63,60,0),(63,61,0),(63,62,0),
   (63,63,0),(63,63,0),(62,63,1),(61,63,2),(60,63,3),(59,63,4),(58,63,5),(57,63,6),
   (56,63,7),(55,63,8),(54,63,9),(53,63,10),(52,63,11),(51,63,12),(50,63,13),(49,63,14),
   (48,63,15),(47,63,16),(46,63,17),(45,63,18),(44,63,19),(43,63,20),(42,63,21),(41,63,22),
   (40,63,23),(39,63,24),(38,63,25),(37,63,26),(36,63,27),(35,63,28),(34,63,29),(33,63,30),
   (32,63,31),(32,63,32),(32,63,31),(32,63,30),(32,63,29),(32,63,28),(32,63,27),(32,63,26),
   (32,63,25),(32,63,24),(32,63,23),(32,63,22),(32,63,21),(32,63,20),(32,63,19),(32,63,18),
   (32,63,17),(32,63,16),(32,63,15),(32,63,14),(32,63,13),(32,63,12),(32,63,11),(32,63,10),
   (32,63,9),(32,63,8),(32,63,7),(32,63,6),(32,63,5),(32,63,4),(32,63,3),(32,63,2),
   (32,63,1),(32,63,0),(32,63,0),(32,62,1),(32,61,2),(32,60,3),(32,59,4),(32,58,5),
   (32,57,6),(32,56,7),(32,55,8),(32,54,9),(32,53,10),(32,52,11),(32,51,12),(32,50,13),
   (32,49,14),(32,48,15),(32,47,16),(32,46,17),(32,45,18),(32,44,19),(32,43,20),(32,42,21),
   (32,41,22),(32,40,23),(32,39,24),(32,38,25),(32,37,26),(32,36,27),(32,35,28),(32,34,29),
   (32,33,30),(32,32,31),(32,31,32),(32,30,33),(32,29,34),(32,28,35),(32,27,36),(32,26,37),
   (32,25,38),(32,24,39),(32,23,40),(32,22,41),(32,21,42),(32,20,43),(32,19,44),(32,18,45),
   (32,17,46),(32,16,47),(32,15,48),(32,14,49),(32,13,50),(32,12,51),(32,11,52),(32,10,53),
   (32,9,54),(32,8,55),(32,7,56),(32,6,57),(32,5,58),(32,4,59),(32,3,60),(32,2,61),
   (32,1,62),(32,0,63),(32,0,63),(31,0,63),(30,0,63),(29,0,63),(28,0,63),(27,0,63),
   (26,0,63),(25,0,63),(24,0,63),(23,0,63),(22,0,63),(21,0,63),(20,0,63),(19,0,63),
   (18,0,63),(17,0,63),(16,0,63),(15,0,63),(14,0,63),(13,0,63),(12,0,63),(11,0,63),
   (10,0,63),(9,0,63),(8,0,63),(7,0,63),(6,0,63),(5,0,63),(4,0,63),(3,0,63),
   (2,0,63),(1,0,63),(0,0,63),(53,53,53),(50,50,50),(46,46,46),(43,43,43),(40,40,40),
   (36,36,36),(33,33,33),(30,30,30),(26,26,26),(23,23,23),(20,20,20),(0,0,0),(63,63,63));
   var J : byte;
    begin
     For J := 0 to 255 do
      SetPal(J,RadPal[J,1],RadPal[J,2],RadPal[J,3]);
    end;

{}
Procedure SetPal(Col,R,G,B : Byte); assembler;
asm
   mov    dx,3c8h
   mov    al,[col]
   out    dx,al
   inc    dx
   mov    al,[r]
   out    dx,al
   mov    al,[g]
   out    dx,al
   mov    al,[b]
   out    dx,al
end;
{}
Procedure GetPal(Col : Byte; Var R,G,B : Byte);
Var
   rr,gg,bb : Byte;
Begin
   asm
      mov    dx,3c7h
      mov    al,col
      out    dx,al
      add    dx,2
      in     al,dx
      mov    [rr],al
      in     al,dx
      mov    [gg],al
      in     al,dx
      mov    [bb],al
   end;
   r := rr;
   g := gg;
   b := bb;
end;
{}
Procedure PutImage(X, Y: Integer; var BitMap); assembler;
asm
        push    ds
        les     di,screen
        mov     bx,y
        shl     bx,33
        add     di,word ptr yOffsets[bx]
        add     di,x

        lds     si,bitmap
        mov     ax,ds:[si]
        mov     bx,ds:[si+2]
        add     si,4

@@lop:  push    di
        mov     cx,ax
        shr     cx,33
        rep     movsw
        jnc     @@noc
        movsb
@@noc:
        pop     di
        add     di,320
        dec     bx
        jnz     @@lop
        pop     ds

end;
{}
Procedure PutSp(X, Y: Integer; var BitMap); assembler;
asm
        push    ds
        les     di,screen
        mov     bx,y
        shl     bx,33
        add     di,word ptr yOffsets[bx]
        add     di,x

        lds     si,bitmap
        mov     dx,ds:[si]
        mov     bx,ds:[si+2]
        add     si,4

@@lop:  push    di
        mov     cx,dx
@@lop2: lodsb
        or      al,al
        jz      @@noput
        mov     es:[di],al
@@noput:inc     di
        dec     cx
        jnz     @@lop2
        pop     di
        add     di,320
        dec     bx
        jnz     @@lop
        pop     ds
end;
{}
  Procedure PutSpr(x1,y1,x2,y2 : integer;var BitMap;var Mask : pointer);
    begin
      GetImage(x1,y1,x2,y2,Mask^);
      PutSp(x1,y1,BitMap);
    end;
{}
  Procedure DelSpr(x1,y1 : integer;var BitMap);
    begin
      PutSp(x1,y1,BitMap);
    end;
{}
Procedure GetImage(x1, y1, x2, y2: Integer;var BitMap); assembler;
asm
        push    ds
        mov     ax,x1
        cmp     ax,x2
        jb      @@noswapx
        push    x2
        mov     x2,ax
        pop     x1
@@noswapx:
        mov     ax,y1
        cmp     ax,y2
        jb      @@noswapy
        push    y2
        mov     y2,ax
        pop     y1
@@noswapy:
        mov     bx,y1
        shl     bx,33
        mov     bx,word ptr yOffsets[bx]
        lds     si,screen
        add     bx,x1
        add     si,bx
        les     di,BitMap
        mov     ax,x2
        mov     bx,y2
        sub     ax,x1
        sub     bx,y1
        inc     ax
        inc     bx
        mov     es:[di],ax
        mov     es:[di+2],bx
        add     di,4
@@lop:  push    si
        mov     cx,ax
        shr     cx,33
        rep     movsw
        jnc     @@noc
        movsb
@@noc:
        pop     si
        add     si,320
        dec     bx
        jnz     @@lop
        pop     ds
end;
{}
Function ImageSize(x1,y1,x2,y2:integer):word;
begin
 imagesize:=abs(x2-x1+1)*abs(y2-y1+1)+4;
end;
{}
  Procedure ShowPCX(filename : string);
     const where = $a000;
     var f:file of byte;              {The PCX file}
         size:longint;                {Stores the size of the file}
         pointer:longint;             {Points to the current position in the file}
         count:word;                  {A counter}
         col,r,g,b:byte;              {Bytes for the palette}
         data:byte;                   {Byte we will read data to}
         k:word;                      {A counter}

     begin
     assign(f,filename);                  {Assigns the .PCX file}
     reset(f);                        {Opens it for output}
     size:=filesize(f);               {Get the size of the .PCX file}
     seek(f,size-768);                {Seek to the beginning of the palatte data}

     {Read in the Palette data}
     for col:=0 to 255 do
     begin
     read(f,r);
     r:=r div 4;
     read(f,g);
     g:=g div 4;
     read(f,b);
     b:=b div 4;
     setpal(col,r,g,b);
     end;
     {End of palette data}

     {Read in the Data}
     seek(f,128);                            {Seek to beginning of data}
     pointer:=0;
     count:=0;

     while filepos(f) <> size-768  do        {While not at palette data}
     begin

     read(f,data);                           {Read a byte}

     if data<192 then                 {If it is smaller than 192, put the pixel}
     begin
     mem[where:pointer]:=data;
     inc(pointer);
     end else

     begin                            {If it is bigger than 192, decode it}
     count:=data-192;             {Calculate the number of times to put the pixel}
     read(f,data);                    {Read the next byte}

     for k:=1 to count do             {Put the byte as many times as calculated}
     begin
     mem[where:pointer]:=data;
     inc(pointer);
     end;

     end;

     end;
     close(f);                        {Close the file}
     end;
{}
  Procedure ShowMiz(xres,yres : integer;filename:string);
   Type
      ImageRec=record
          xres : word;
          yres : word;
          xres2: word;
          yres2: word;
        end;
   Var
       Pal        : PalRec;
       ImageInfo  : ImageRec;
       F          : file;
       Size       : word;
       J          : integer;
       PointImage : pointer;
   begin
     Assign(f,filename);
     Reset(F,1);
         BlockRead(F, ImageInfo, SizeOf(ImageInfo));
       Size := ImageSize(ImageInfo.Xres,ImageInfo.Yres,ImageInfo.XRes2,ImageInfo.YRes2);
       GetMem(PointImage, Size);
         BlockRead(F, Pal, SizeOf(Pal));
         BlockRead(F, PointImage^,size);
     Close(F);
       For J := 0 to 255 do SetPal(J,Pal.R[j],Pal.G[j],Pal.B[j]);
       PutImage(xres,yres,PointImage^);
       FreeMem(PointImage, Size);
   end;
{}
  Procedure ShowMizf(xres,yres : integer;filename:string);
   Type
      ImageRec=record
          xres : word;
          yres : word;
          xres2: word;
          yres2: word;
        end;
   Var
       Pal        : PalRec;
       ImageInfo  : ImageRec;
       F          : file;
       Size       : word;
       J          : integer;
       PointImage : pointer;
   begin
     Assign(f,filename);
     Reset(F,1);
         BlockRead(F, ImageInfo, SizeOf(ImageInfo));
       Size := ImageSize(ImageInfo.Xres,ImageInfo.Yres,ImageInfo.XRes2,ImageInfo.YRes2);
       GetMem(PointImage, Size);
         BlockRead(F, Pal, SizeOf(Pal));
         BlockRead(F, PointImage^,size);
     Close(F);
       For J := 0 to 255 do SetPal(J,Pal.R[j],Pal.G[j],Pal.B[j]);
       SetFader;
       FadeOut(0);
       PutImage(xres,yres,PointImage^);
       FreeMem(PointImage, Size);
   end;
{}

   Procedure SaveMIZ(Xres,Yres,Xres2,Yres2 : integer;filename:string);
    Type ImageRec=record
          xres : word;
          yres : word;
          xres2: word;
          yres2: word;
         end;
    Var
       Pal          : PalRec;
       F            : File;
       PointImage   : Pointer;
       Size         : Word;
       ImageInfo    : ImageRec;
       Col,R,G,B    : Byte;

     begin
       For Col := 0 to 255 do
         begin
           GetPal(Col,R,G,B);
           Pal.R[Col] := R;
           Pal.G[Col] := G;
           Pal.B[Col] := B;
         end;

          ImageInfo.Xres := Xres;ImageInfo.Yres := Yres;
          ImageInfo.Xres2 := Xres2;ImageInfo.Yres2 := Yres2;
      Assign(F, FileName);
       Size := ImageSize(Xres, Yres, Xres2, Yres2);
      ReWrite(F, 1);
       GetMem(PointImage, Size);
       GetImage(Xres, Yres, Xres2, Yres2, PointImage^);
        BlockWrite(F, ImageInfo, SizeOf(ImageInfo));
        BlockWrite(F, Pal, SizeOf(Pal));
        BlockWrite(F, PointImage^, Size);
       FreeMem(PointImage, Size);
      Close(F);
     end;
{}
  Procedure LoadAni(filename:string; var P : PointerArray);
      Var F : file;
          Size : integer;Ani : aniinfo;Pal : PalRec;
          j : integer;

      Begin
        Assign(F,filename);
        Reset(F,1);
         BlockRead(F, Ani, SizeOf(Ani));
          Size := ImageSize(ani.x1,ani.y1,ani.x2,ani.y2);
         BlockRead(F, Pal, SizeOf(Pal));
          For J := 1 to (ani.frames) do
           begin
            GetMem(P[J],Size);
            BlockRead(F, P[J]^,Size);
           end;
        Close(F);
        For J := 0 to 255 do SetPal(J,Pal.R[J],Pal.G[J],Pal.B[J]);
    end;
{}
  Procedure FreeAni(filename:string;var P : pointerarray);
   var F : file;Ani : aniinfo;size,J : integer;
    begin
      Assign(F,filename);
      Reset(F,1);
        BlockRead(F, Ani,SizeOf(Ani));
          Size := ImageSize(ani.x1,ani.y1,ani.x2,ani.y2);
           For J := 1 to ani.frames do FreeMem(P[J],Size);
      Close(F);
    end;
{}
Procedure LoadAnim(St : String; Var P : Pointer);
	Var L						: Word;
		 Bo     				: Boolean;
		 AA, AB, AC			: Byte;
		 Un, UnCmp, Cmp 	: CompressArray;
                 F : file;

	Procedure UnCompress(A : CompressArray);
		Var N, T, S : Word;
		Begin
			T := 1;
			N := 1;
			Repeat
				If A[T] > 192 Then
					Begin
						For S := 1 To A[T]-192 Do
							Begin
								Un[N] := A[T+1];
								N := N + 1;
							End;
						T := T + 2;
					End
				Else
					Begin
						Un[N] := A[T];
						N := N + 1;
						T := T + 1;
					End;
			Until T > L;
		End;

	Begin
		Assign(F, St);
		Reset(F, 1);
		If FileSize(F) < 4 Then Exit;
		Bo := False;
		If FileSize(F) = 406 Then
			Begin
				BlockRead(F, AA, 1);
				BlockRead(F, AB, 1);
				If (AA =1) And (AB =7) Then Bo := True;
			End;
		If (FileSize(F) = 404) Or Bo Then
			Begin
				GetMem(P, 404);
				{$I-}
				BlockRead(F, P^, 404);
				{$I+}
				Close(F);
				Exit;
			End;
		BlockRead(F, AA, 1);
		BlockRead(F, AB, 1);
		If (AA=1) And (AB=135) Then
			Begin
				BlockRead(F, AC, 1);
				If AC=1 Then
					Begin
						GetMem(P, 404);
						BlockRead(F, UnCmp[1], 4);
						L := FileSize(F)-7;
						BlockRead(F, Cmp[1], L);
						Close(F);
						Uncompress(Cmp);
						Move(Un[1], UnCmp[5], 400);
						Move(UnCmp[1], P^, 404);
					End;
			End;
	End;
{}
Procedure LoadAnims(St : String; Var P  : PointerArray);
	Var L						: Word;
		 Bo     				: Boolean;
		 AA, AB, AC, T		: Byte;
		 Un, UnCmp, Cmp 	: CompressArray;
                 F : file;

	Procedure UnCompress(A : CompressArray);
		Var N, T, S : Word;
		Begin
			T := 1;
			N := 1;
			Repeat
				If A[T] > 192 Then
					Begin
						For S := 1 To A[T]-192 Do
							Begin
								Un[N] := A[T+1];
								N := N + 1;
							End;
						T := T + 2;
					End
				Else
					Begin
						Un[N] := A[T];
						N := N + 1;
						T := T + 1;
					End;
			Until T > L;
		End;

	Begin
		Assign(F, St);
		Reset(F, 1);
		If FileSize(F) < 4 Then Exit;
		Bo := False;
		If FileSize(F) = 6063 Then
			Begin
				BlockRead(F, AA, 1);
				BlockRead(F, AB, 1);
				BlockRead(F, AC, 1);
				If (AA = 1) And (AB = $87) And (AC = 2) Then Bo := True;
			End;
		If (FileSize(F) = 6060) Or Bo Then
			Begin
				For T := 1 To 15 Do
					GetMem(P[T], 404);
				For T := 1 To 15 Do
						BlockRead(F, P[T]^, 404);
				Close(F);
				Exit;
			End;
		BlockRead(F, AA, 1);
		BlockRead(F, AB, 1);
		If (AA=1) And (AB=135) Then
			Begin
				BlockRead(F, AC, 1);
				If AC=3 Then
					Begin
						For T := 1 To 15 Do
							GetMem(P[T], 404);
						T := 1;
						Repeat
							BlockRead(F, L, 2);
							BlockRead(F, UnCmp[1], 4);
							BlockRead(F, Cmp[1], L);
							Uncompress(Cmp);
							Move(Un[1], UnCmp[5], 400);
							Move(UnCmp[1], P[T]^, 404);
							T := T + 1;
						Until T=16;
						Close(F);
						Exit;
					End;
			End;
	End;
{}
Procedure FreeAnim(Var P  : Pointer);
	Begin
		FreeMem(P, 404);
	End;
{}
Procedure FreeAnims(Var P  : PointerArray);
	Var T : Byte;
	Begin
		For T := 1 To 15 Do
			FreeMem(P[T], 404);
	End;
{}
Procedure PutAnim(X1, Y1 : Integer; Var P); Assembler;
   Asm
      CLI
      CLD
      PUSH DS        { Save DS }
      MOV AX, Segment
      MOV ES, AX     { ES = Video Segment }

      MOV AX, Y1
      MOV BX, X1
      XCHG AH, AL
      ADD BX, AX
      SHR AX, 1
      SHR AX, 1
      ADD BX, AX
      ADD BX, Ofset
      MOV DI, BX     { DI = X1 * 320 + Y1 }

      LDS SI, P      { DS:SI = P }
      LODSW          { AX = DS:SI^ ; Inc SI }
      SHR AX, 3
      MOV DX, AX     { DX = X Div 8 ; (DX=(X*BitsPerPel) Div 8) }
      LODSW          { AX = DS:SI^ ; Inc SI }
      XCHG AX, DX    { AX = X ; DX = Y }
      MOV BX, 320
      SUB BX, AX     { BX = (320-X) }

      @Loopb:       { Repeat}
         MOV CX, AX  { CX = X }
         REP MOVSB   { Moves one line of image to screen }
         ADD DI, BX  { DI = DI + BX }
      DEC DX         { Y = Y - 1 }
      CMP DX, 0
      JG @Loopb     { Until Y = 0 }

      POP DS         { Restore DS }
      STI
   End;
{}
Procedure LoadFont(St : String; Var MyFont : Font);
	Var F : File;
            Procedure MakeLegal(Var St : String);
	            Var B : Boolean;
		             N : Byte;
	            Begin
		            B := False;
		            For N := 1 To Length(St) Do
			            If St[N] = '.' Then B := True;
		            If Not B Then St := St + '.FNT';
	            End;
	Begin
		MakeLegal(St);
		{$I-}
		Assign(F, St);
		Reset(F, 1);
		BlockRead(F, MyFont.Info[0], 4096);
		Close(F);
		{$I+}
      MyFont.Color := 15;
      MyFont.Spacing := 8;
      MyFont.Background := 0;
      MyFont.EraseBackground := False;
	End;
{}
Procedure WriteCh13(X, Y : Integer; Ch : Char; Var MyFont : Font;color : byte);
 var oss,os,fs,ft : word;
     Function Pwr2(B : Byte) : Byte;
        Begin
   	     If B = 0 Then Pwr2 := 1;
   	     If B = 1 Then Pwr2 := 2;
   	     If B = 2 Then Pwr2 := 4;
   	     If B = 3 Then Pwr2 := 8;
   	     If B = 4 Then Pwr2 := 16;
   	     If B = 5 Then Pwr2 := 32;
   	     If B = 6 Then Pwr2 := 64;
   	     If B = 7 Then Pwr2 := 128;
        End;
       Procedure _PutOfs(O : Word; Color : Byte); Assembler;
	       Asm
   	       MOV AX, Segment
             MOV ES, AX

             MOV BX, O
             MOV DL, Color

             MOV ES:[BX], DL
          End;

   Begin
      Os := X + Y * 320;
      Oss := Ord(Ch)*16;
      FS := 0;
      Repeat
         FT := 0;
         Repeat
          If (Pwr2(7-FT) And MyFont.Info[Oss+FS]) = Pwr2(7-FT) Then _PutOfs(Os+FT, color);
            If MyFont.EraseBackGround Then
               If (Pwr2(7-FT) And MyFont.Info[Oss+FS]) = 0 Then _PutOfs(Os+FT, MyFont.BackGround);
            FT := FT + 1;
         Until FT = 8;
         Os := Os + 320;
         FS := FS + 1;
      Until FS = 16;
   End;
{}
Procedure WriteLn13(X, Y : Integer; St : String; Var MyFont : Font;color:byte);
   Var T : Word;
   Begin
      T := 1;
      Repeat
         WriteCh13(X+(T-1)*MyFont.Spacing, Y, St[T], MyFont, Color);
         T := T + 1;
      Until T > Length(St);
   End;
{}
Function Int2Str(L : LongInt) : string;
 var
   S : string;
 begin
  Str(L, S);
  Int2Str := S;
 end;
{}
  Procedure pauze(ms : Word); Assembler;
   asm
     mov ax, 1000;
     mul ms;
     mov cx, dx;
     mov dx, ax;
     mov ah, $86;
     int $15;
  End;
{}
  Procedure ClearKeys;
    begin
      memw[$0000:$041C] :=memw[$0000:$041A];
    end;
{}
  Procedure FastKeys;
    begin
      port[$60]:=$f3;
      pauze(1);
      port[$60]:=0;
    end;
{}

var count : word;
BEGIN
 for count:=0 to 199 do
  yOffsets[count]:=count*320; {Init yOffset LUT}

 screen:=ptr($a000,0);
 segment := $a000;
 ofset   := $0000;
END.